#ifndef INCLUDED_phoenix_geometry_ComplexGeometry
#define INCLUDED_phoenix_geometry_ComplexGeometry

#ifndef HXCPP_H
#include <hxcpp.h>
#endif

#include <phoenix/geometry/Geometry.h>
HX_DECLARE_CLASS0(IMap)
HX_DECLARE_CLASS2(haxe,ds,StringMap)
HX_DECLARE_CLASS1(phoenix,Color)
HX_DECLARE_CLASS1(phoenix,Rectangle)
HX_DECLARE_CLASS1(phoenix,Vector)
HX_DECLARE_CLASS2(phoenix,geometry,ComplexGeometry)
HX_DECLARE_CLASS2(phoenix,geometry,Geometry)
namespace phoenix{
namespace geometry{


class HXCPP_CLASS_ATTRIBUTES  ComplexGeometry_obj : public ::phoenix::geometry::Geometry_obj{
	public:
		typedef ::phoenix::geometry::Geometry_obj super;
		typedef ComplexGeometry_obj OBJ_;
		ComplexGeometry_obj();
		Void __construct(Dynamic _options);

	public:
		inline void *operator new( size_t inSize, bool inContainer=true)
			{ return hx::Object::operator new(inSize,inContainer); }
		static hx::ObjectPtr< ComplexGeometry_obj > __new(Dynamic _options);
		static Dynamic __CreateEmpty();
		static Dynamic __Create(hx::DynamicArray inArgs);
		//~ComplexGeometry_obj();

		HX_DO_RTTI;
		static void __boot();
		static void __register();
		void __Mark(HX_MARK_PARAMS);
		void __Visit(HX_VISIT_PARAMS);
		::String __ToString() const { return HX_CSTRING("ComplexGeometry"); }

		::haxe::ds::StringMap quads;
		virtual Void clear( );
		Dynamic clear_dyn();

		virtual ::String quad_add( Dynamic _options);
		Dynamic quad_add_dyn();

		virtual Void quad_remove( ::String _quad_id);
		Dynamic quad_remove_dyn();

		virtual Void quad_hide( ::String _quad_id);
		Dynamic quad_hide_dyn();

		virtual Void quad_show( ::String _quad_id);
		Dynamic quad_show_dyn();

		virtual Void quad_resize( ::String _quad_id,::phoenix::Rectangle _quad);
		Dynamic quad_resize_dyn();

		virtual Void quad_pos( ::String _quad_id,::phoenix::Vector _p);
		Dynamic quad_pos_dyn();

		virtual Void quad_color( ::String _quad_id,::phoenix::Color _c);
		Dynamic quad_color_dyn();

		virtual Void quad_alpha( ::String _quad_id,Float _a);
		Dynamic quad_alpha_dyn();

		virtual Void quad_uv_space( ::String _quad_id,::phoenix::Rectangle _uv);
		Dynamic quad_uv_space_dyn();

		virtual Void quad_uv( ::String _quad_id,::phoenix::Rectangle _uv);
		Dynamic quad_uv_dyn();

		virtual Void quad_flipx( ::String _quad_id,bool _flip);
		Dynamic quad_flipx_dyn();

		virtual Void quad_flipy( ::String _quad_id,bool _flip);
		Dynamic quad_flipy_dyn();

};

} // end namespace phoenix
} // end namespace geometry

#endif /* INCLUDED_phoenix_geometry_ComplexGeometry */ 
